<?php

namespace Teknisa\COC\Services;

use Zeedhi\Framework\DTO\Response\Error;
use \Doctrine\ORM\EntityManager;

class PrecificacaoItemfatService {
	protected $connection;
	protected $entityManager;

	protected $COLUMNS_NAME = 'CDFILIAL;CDCIA;CDMANCIA;NRORG;CDSUBGRU;NRSEQSUBGRUSEMAM;CDCICLO;CDCLASSE;NRSERVICOCIAFILI;NRSERVICOCIAFILIPRECO;Item de Faturamento;Sub-Grupo;Inicio Vigencia;Fim Vigencia;Ciclo;Classe;Tipo de Loading;Loading;Preco Real;Preco Dolar;TABELA PROPORCIONAL;Utiliza Loading;';

	public function __construct(EntityManager $entityManager) {
		$this->connection = $entityManager->getConnection();
		$this->entityManager = $entityManager;
	}

	public function getColumnsName(){
		return $this->COLUMNS_NAME;
	}

	public function findItensFat($cdfilial, $nrorg, $cdcia, $cdmancia, $dtinivg, $dtfimvg, $nrservicociafili, $cdclasse, $cdciclo, $qtd_max) {
		$columns = $this->createColumnsforItensFat($qtd_max);
		$params = array(
			"CDFILIAL" 			=> $cdfilial,
			"NRORG" 			=> $nrorg,
			"CDCIA" 			=> $cdcia,
			"CDMANCIA" 			=> $cdmancia,
			"DTINIVG" 			=> $dtinivg,
			"DTFIMVG" 			=> $dtfimvg,
			"NRSERVICOCIAFILI"  => $nrservicociafili,
			"CDCLASSE" 			=> $cdclasse,
			"CDCICLO"  			=> $cdciclo
		);
		$query = 'SELECT PSG.CDFILIAL, PSG.CDCIA, PSG.CDMANCIA, PSG.NRORG, PSG.CDSUBGRU, PSG.NRSEQSUBGRUSEMAM, PSG.CDCICLO, PSG.CDCLASSE, PSG.NRSERVICOCIAFILI AS NRSERVICOCIAFILI, PSG.NRSERVICOCIAFILIPRECO AS NRSERVICOCIAFILIPRECO, SCC.DSSERVICOCIAFILI AS "Item de Faturamento", SG.DSSUBGRU AS "Sub-Grupo", SUBSTR(SGS.DTINIVGSUMA, 0, 10) AS "Inicio Vig.", SUBSTR(SGS.DTFIMVGSUMA, 0, 10) AS "Fim Vig.", CC.IDCICLO AS "Ciclo", CL.SGCLASSE AS "Sigla", SGS.IDPROPSUBSEMAM AS "Tipo de Loading", SGS.QTPROPSUBSEMAM AS "Loading", NULL AS "Preco Real", NULL AS "Preco Dolar", NULL AS "TABELA PROPORCIONAL", NULL AS "Utiliza Loading" '. $columns .' FROM PRECOSESUBGRU PSG JOIN SUBGRUSEMAM SGS ON PSG.CDFILIAL = SGS.CDFILIAL AND PSG.CDCIA = SGS.CDCIA AND PSG.CDMANCIA = SGS.CDMANCIA AND PSG.NRSERVICOCIAFILI = SGS.NRSERVICOCIAFILI AND PSG.CDCLASSE = SGS.CDCLASSE AND PSG.CDSUBGRU = SGS.CDSUBGRU AND PSG.NRSEQSUBGRUSEMAM = SGS.NRSEQSUBGRUSEMAM JOIN MANUALCIAM MN ON MN.CDFILIAL = SGS.CDFILIAL AND MN.CDCIA = SGS.CDCIA AND MN.CDMANCIA = SGS.CDMANCIA AND MN.NRORG = SGS.NRORG JOIN SERVCICLO SC ON SC.CDFILIAL = PSG.CDFILIAL AND SC.CDCIA = PSG.CDCIA AND SC.NRSERVICOCIAFILI = PSG.NRSERVICOCIAFILIPRECO AND SC.CDCLASSE = PSG.CDCLASSE AND SC.CDCICLO = PSG.CDCICLO JOIN SERVICOCIAFILI SCC ON SCC.CDFILIAL = PSG.CDFILIAL AND SCC.CDCIA = PSG.CDCIA AND SCC.NRSERVICOCIAFILI = PSG.NRSERVICOCIAFILIPRECO JOIN CICLO CC ON CC.CDCICLO = PSG.CDCICLO JOIN SUBGRUPOM SG ON SG.CDSUBGRU = PSG.CDSUBGRU JOIN CLASSE CL ON CL.CDCLASSE = PSG.CDCLASSE WHERE PSG.CDFILIAL = :CDFILIAL AND PSG.CDCIA = :CDCIA AND VERIF_VALOR_LISTA(PSG.CDMANCIA, :CDMANCIA) IS NOT NULL AND VERIF_VALOR_LISTA(PSG.NRSERVICOCIAFILIPRECO, :NRSERVICOCIAFILI) IS NOT NULL AND PSG.NRORG = :NRORG AND MN.IDSITUAPROPCIA IN (\'A\', \'P\') AND((SGS.DTINIVGSUMA BETWEEN :DTINIVG AND :DTFIMVG) OR(SGS.DTFIMVGSUMA BETWEEN :DTINIVG AND :DTFIMVG) OR(:DTFIMVG BETWEEN SGS.DTINIVGSUMA AND SGS.DTFIMVGSUMA) OR(:DTINIVG BETWEEN SGS.DTINIVGSUMA AND SGS.DTFIMVGSUMA)) AND VERIF_VALOR_LISTA(PSG.CDCLASSE, :CDCLASSE) IS NOT NULL AND VERIF_VALOR_LISTA(PSG.CDCICLO, :CDCICLO) IS NOT NULL ORDER BY CL.SGCLASSE, PSG.CDCLASSE, CC.IDCICLO, PSG.CDCICLO, SCC.DSSERVICOCIAFILI, PSG.NRSERVICOCIAFILIPRECO, SG.DSSUBGRU, PSG.CDSUBGRU';
		$rows = $this->connection->fetchAll($query, $params);
		return $rows;
	}
	public function findMaxEquipcia($cdcia, $cdfilial, $nrorg){
		$params = array(
			"CDCIA" => $cdcia,
			"CDFILIAL" => $cdfilial,
			"NRORG" => $nrorg
		);
		$query = 'SELECT MAX(QTTOTPAXPREF) AS MAX FROM PREFIXOCIA WHERE CDCIA = :CDCIA AND CDFILIAL = :CDFILIAL AND NRORG = :NRORG';
		$rows = $this->connection->fetchAll($query, $params);
		if($rows[0]['MAX']){ 
			return $rows[0]['MAX'];
		} else {
			$query = 'SELECT MAX(QTTOTPAX) AS MAX FROM EQUIPCIA WHERE CDCIA = :CDCIA AND CDFILIAL = :CDFILIAL AND NRORG = :NRORG';
			$rows = $this->connection->fetchAll($query, $params);
			if($rows[0]['MAX']){
				return $rows[0]['MAX'];
			} else { 
				return 100; //Quantidade default total pax
			}
		}
		$rows = $this->connection->fetchAll($query, $params);
	}
	public function findPrecoTabelaProp($cdfilial, $cdcia, $cdmancia, $nrservicociafili, $cdsubgru, $nrorg) {
		$params = array(
			"CDFILIAL" => $cdfilial,
			"CDCIA" => $cdcia,
			"CDMANCIA" => $cdmancia,
			"NRSERVICOCIAFILI" => $nrservicociafili,
			"CDSUBGRU" => $cdsubgru,
			"NRORG" => $nrorg
		);
		$query = 'SELECT CDFILIAL, CDCIA, CDMANCIA, NRSERVICOCIAFILI, CDSUBGRU, QTPAXDE, QTPAXATE, QTSUBGRUPO, NRORG FROM PROPSUBGRUSE WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND CDMANCIA = :CDMANCIA AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDSUBGRU = :CDSUBGRU AND NRORG = :NRORG';
		$rows = $this->connection->fetchAll($query, $params);
		return $rows;
	}
	public function createColumnsPax ($qtd_max){
		for($i = 1; $i<=$qtd_max; $i++)
			$this->COLUMNS_NAME .= $i.";";
	}
	public function createColumnsforItensFat ($qtd_max){
		$columns = null;
		for($i = 1; $i<=$qtd_max; $i++)
			$columns .= ', NULL AS '. '"'.$i.'"';
		return $columns;
	}
}